<template>
  <div class="star">
    <div v-if="star">
      <h1 class="mt-3">{{ star.englishName }}</h1>
      <p>
        {{ star.englishName }} is
        {{ star.isPlanet ? "a planet" : "not a planet" }} with actually
        {{ star.moons === null ? "0" : "some" }} moon(s). {{ star.name }} was
        discovered by
        {{ star.discoveredBy === "" ? "Unknown" : star.discoveredBy }} on
        {{ star.discoveryDate === "" ? "Unknown date" : star.discoveryDate }}
      </p>

      <b-table striped hover :items="this.informations"></b-table>

      <h2>Moons</h2>
      <div v-if="star.moons !== null">
        <BadgeGroup :moons="star.moons" />
      </div>
      <p v-else>{{ star.name }} ({{ star.englishName }}) has no moons.</p>
    </div>
    <div v-else>
      <b-spinner label="Spinning"></b-spinner>
    </div>
  </div>
</template>

<script>
import BadgeGroup from "./../../components/Badge/BadgeGroup.vue";
import StarsAPI from "./../../services/index.js";

export default {
  components: {
    BadgeGroup
  },
  computed: {
    informations() {
      return [
        {
          Label: "English name",
          Value: this.star.englishName
        },
        {
          Label: "Density",
          Value: this.star.density
        },
        {
          Label: "Gravity",
          Value: this.star.gravity
        },
        {
          Label: "Semimajor Axis",
          Value: this.star.semimajorAxis
        },
        {
          Label: "Discovered by",
          Value: this.star.discoveredBy
        },
        {
          Label: "Discovered date",
          Value: this.star.discoveryDate
        }
      ];
    }
  },
  async asyncData({ params }) {
    const slug = params.slug;
    const star = await StarsAPI.find(slug);
    return { star };
  }
};
</script>
